#!/bin/sh
prog_name=YiffIndex1.14
rm *.zip install_*.exe install_*.jar

unix2dos start_izpack.bat
unix2dos ../Start.bat
~/IzPack/bin/compile install.xml -b . -o install_$prog_name.jar -k standard
python ~/IzPack/utils/wrappers/izpack2exe/izpack2exe.py --file=install_$prog_name.jar --output=install_$prog_name.exe --no-upx
python ~/IzPack/utils/wrappers/izpack2app/izpack2app.py install_$prog_name.jar install_$prog_name.app
zip -r install_$prog_name.app.zip install_$prog_name.app/
rm -rf install_$prog_name.app/

cp -r ../../YiffIndex/ /tmp/YiffIndex
this_path=$PWD
cd /tmp
find YiffIndex/ -type f -name "*.java" -delete
rm YiffIndex/build.xml
rm YiffIndex/log.txt
rm YiffIndex/.project
rm YiffIndex/.classpath
rm YiffIndex/db/YiffIndexDB.*
rm -rf YiffIndex/izpack_stuff
rm -rf YiffIndex/plugins/*
zip -r $this_path/$prog_name.zip YiffIndex
rm -rf YiffIndex
cd $this_path

cp -r ../../YiffIndex/ /tmp/YiffIndex
cd /tmp
find YiffIndex/ -type f -name "*.class" -delete
rm YiffIndex/log.txt
rm YiffIndex/.project
rm YiffIndex/.classpath
rm YiffIndex/db/YiffIndexDB.*
# rm -rf YiffIndex/izpack_stuff
rm YiffIndex/izpack_stuff/*.zip
rm YiffIndex/izpack_stuff/*.jar
rm YiffIndex/izpack_stuff/*.exe
rm -rf YiffIndex/plugins/*
zip -r $this_path/${prog_name}_source.zip YiffIndex
rm -rf YiffIndex
cd $this_path
