package allrounder.logger;

import javax.swing.JOptionPane;

import allrounder.StringLib;

public class TopLevelExceptionHandler {
	public TopLevelExceptionHandler() {}
	public void handle(Throwable t) {
		t.printStackTrace(Logwriter.getInstance().getPrintStream());
		t.printStackTrace();
		String mess = (t.getLocalizedMessage() == null) ? 
				((t.getMessage() == null) ? t.getClass().getName() : (t.getClass().getName() + ": " + t.getMessage())) :
					t.getClass().getName() + ": " + t.getLocalizedMessage();
		JOptionPane.showMessageDialog(null, StringLib.getInstance().getValue("TopLevelExceptionHandler.error.text", "", mess), StringLib.getInstance().getValue("TopLevelExceptionHandler.error.title"), JOptionPane.ERROR_MESSAGE);
   }
}